//! Find Elves that can be lazy
//! 
//! Lazy Elves are Elves whose given section ID range are completely contained 
//! by its pair mate section ID range.
//! 
//! The input file is a list of Elf section ID ranges, a pair at a line
//! 
//! ## Example
//! ```bash
//! cargo run -- ../input.txt # Execute the program with the input file
//! ```

use std::fs;
use std::env;

mod camp;

fn main() {
    let args: Vec<String> = env::args().collect();
    let filename = &args[1];
    let contents: String = fs::read_to_string(filename)
        .expect("Something went wrong reading the file");
    println!("{}", camp::count_lazy_elves(&contents));
}